import React from 'react';
import PropTypes from 'prop-types';
import SuiSwitch from '@s-ui/react-atom-switch';
export default function InfoCard(_ref) {
  var title = _ref.title,
      descriptions = _ref.descriptions,
      state = _ref.state,
      onStateChange = _ref.onStateChange;

  var handleToggle = function handleToggle(_ref2) {
    var index = _ref2.index,
        value = _ref2.value;
    onStateChange({
      index: index,
      value: value
    });
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("h3", null, title), Object.keys(descriptions).map(function (key, index) {
    return /*#__PURE__*/React.createElement("div", {
      key: key + "-" + index
    }, /*#__PURE__*/React.createElement("p", null, descriptions[key].name), /*#__PURE__*/React.createElement(SuiSwitch, {
      label: "",
      type: "single",
      name: title + "-consents-" + key,
      value: state.consents[key],
      onToggle: function onToggle() {
        return handleToggle({
          index: key,
          value: state.consents[key]
        });
      }
    }));
  }));
}
InfoCard.displayName = 'InfoCard';