import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import React, { useState, useEffect } from 'react';
import PropTypes from 'prop-types';
import SuiButton from '@s-ui/react-atom-button';
import SuiModal from '@s-ui/react-molecule-modal';
import IconClose from './components/IconClose';
import InfoCard from './components/InfoCard';
export default function TcfFirstLayer(_ref) {
  var loadUserConsent = _ref.loadUserConsent,
      getVendorList = _ref.getVendorList,
      saveUserConsent = _ref.saveUserConsent,
      openSecondLayer = _ref.openSecondLayer;

  var _useState = useState(true),
      saveButtonDisabled = _useState[0],
      setSaveButtonDisabled = _useState[1];

  var _useState2 = useState(null),
      state = _useState2[0],
      setState = _useState2[1];

  var _useState3 = useState(null),
      vendorListState = _useState3[0],
      setVendorListState = _useState3[1];

  var _useState4 = useState(true),
      modalOpen = _useState4[0],
      setModalOpen = _useState4[1];

  useEffect(function () {
    var loadConsent = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var _yield$loadUserConsen, purpose;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return loadUserConsent();

              case 2:
                _yield$loadUserConsen = _context.sent;
                purpose = _yield$loadUserConsen.purpose;
                setState({
                  purposes: purpose
                });

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function loadConsent() {
        return _ref2.apply(this, arguments);
      };
    }();

    var loadVendorList = /*#__PURE__*/function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
        var _yield$getVendorList, purposes;

        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return getVendorList();

              case 2:
                _yield$getVendorList = _context2.sent;
                purposes = _yield$getVendorList.purposes;
                setVendorListState({
                  purposes: purposes
                });

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function loadVendorList() {
        return _ref3.apply(this, arguments);
      };
    }();

    loadConsent();
    loadVendorList();
  }, [getVendorList, loadUserConsent]);

  var handleSettingsClick = function handleSettingsClick() {
    openSecondLayer();
  };

  var handleSaveExitClick = function handleSaveExitClick() {
    saveUserConsent({
      purpose: state.purposes
    });
    setModalOpen(false);
  };

  var handleAcceptAll = function handleAcceptAll() {
    setState(function (prevState) {
      var purposes = prevState.purposes;
      var consents = purposes.consents;

      for (var key in consents) {
        consents[key] = true;
      }

      return {
        purposes: {
          consents: consents
        }
      };
    });
    setSaveButtonDisabled(false);
  };

  var handlePurposesChange = function handlePurposesChange(_ref4) {
    var index = _ref4.index,
        value = _ref4.value;
    setSaveButtonDisabled(false);
    setState(function (prevState) {
      var purposes = prevState.purposes;
      var consents = purposes.consents;
      consents[index] = !value;
      return {
        purposes: {
          consents: consents
        }
      };
    });
  };

  var handleCloseModal = function handleCloseModal() {
    setModalOpen(false);
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "sui-TcfFirstLayer"
  }, /*#__PURE__*/React.createElement(SuiModal, {
    isOpen: modalOpen,
    closeOnOutsideClick: true,
    closeOnEscKeyDown: true,
    header: /*#__PURE__*/React.createElement("strong", null, "TcfFirstLayer"),
    iconClose: /*#__PURE__*/React.createElement(IconClose, null),
    onClose: handleCloseModal
  }, state && vendorListState && /*#__PURE__*/React.createElement(InfoCard, {
    title: "We care about your privacy",
    descriptions: vendorListState.purposes,
    state: state.purposes,
    onStateChange: handlePurposesChange
  }), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(SuiButton, {
    onClick: handleSettingsClick
  }, "Manage Settings"), /*#__PURE__*/React.createElement(SuiButton, {
    onClick: handleSaveExitClick,
    disabled: saveButtonDisabled
  }, "Save and Exit"), /*#__PURE__*/React.createElement(SuiButton, {
    onClick: handleAcceptAll
  }, "Accept All")));
}
TcfFirstLayer.displayName = 'TcfFirstLayer';